From: Andrew Johnson <anj@aps.anl.gov>
Date: Fri, 13 May 2016 13:30:55 -0500
Subject: Applied Till's fix for lp:1581212

---
 src/ioc/db/db_access.c | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

diff --git a/src/ioc/db/db_access.c b/src/ioc/db/db_access.c
index 3e957b4..c536318 100644
--- a/src/ioc/db/db_access.c
+++ b/src/ioc/db/db_access.c
@@ -42,7 +42,7 @@
 #include "dbNotify.h"
 #include "dbStaticLib.h"
 #include "recSup.h"
-
+#include "dbLock.h"
 
 #define oldDBF_STRING      0
 #define oldDBF_INT         1
@@ -153,6 +153,8 @@ int dbChannel_get_count(
     * in the dbAccess.c dbGet() and getOptions() routines.
     */
 
+    dbScanLock(dbChannelRecord(chan));
+
     switch(buffer_type) {
     case(oldDBR_STRING):
         status = dbChannelGetField(chan, DBR_STRING, pbuffer, &zero, nRequest, pfl);
@@ -791,8 +793,12 @@ int dbChannel_get_count(
         }
         break;
     default:
-        return -1;
+        status = -1;
+        break;
     }
+
+    dbScanUnlock(dbChannelRecord(chan));
+
     if (status) return -1;
     return 0;
 }
